var util = require( "util" );

function CacheDisabledError() {
	var message = util.format.apply( null, arguments );
	this.name = "CacheDisabledError";
	this.message = message || "";
}
CacheDisabledError.prototype = Object.create( Error.prototype );
CacheDisabledError.prototype.constructor = CacheDisabledError;

function CacheMissError() {
	var message = util.format.apply( null, arguments );
	this.name = "CacheMissError";
	this.message = message || "";
}
CacheMissError.prototype = Object.create( Error.prototype );
CacheMissError.prototype.constructor = CacheMissError;

function CacheNotYetConnectedError() {
	var message = util.format.apply( null, arguments );
	this.name = "CacheNotYetConnectedError";
	this.message = message || "";
}
CacheNotYetConnectedError.prototype = Object.create( Error.prototype );
CacheNotYetConnectedError.prototype.constructor = CacheNotYetConnectedError;

function InvalidStrategyError() {
	var message = util.format.apply( null, arguments );
	this.name = "InvalidStrategyError";
	this.message = message || "";
}
InvalidStrategyError.prototype = Object.create( Error.prototype );
InvalidStrategyError.prototype.constructor = InvalidStrategyError;

function UnknownStrategyError() {
	var message = util.format.apply( null, arguments );
	this.name = "UnknownStrategyError";
	this.message = message || "";
}
UnknownStrategyError.prototype = Object.create( Error.prototype );
UnknownStrategyError.prototype.constructor = UnknownStrategyError;

global.CacheDisabledError = CacheDisabledError;
global.CacheMissError = CacheMissError;
global.CacheNotYetConnectedError = CacheNotYetConnectedError;
global.InvalidStrategyError = InvalidStrategyError;
global.UnknownStrategyError = UnknownStrategyError;
